﻿Imports DynaviewModbus

Public Class DynaviewModbusClient
    ' Create the ToolTip and associate with the Form container.
    Private toolTip1 As New ToolTip()

    Private dvm As DynaviewModbus.Dynaview
    ' update the index number on the screen when the combo box changes
    Private Sub cbLenUnits_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cbLenUnits.SelectedIndexChanged
        tbLenIdx.Text = cbLenUnits.SelectedIndex.ToString
    End Sub
    ' update the index number on the screen when the combo box changes
    Private Sub cbSpeedUnits_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles cbSpeedUnits.SelectedIndexChanged
        tbSpdIdx.Text = cbSpeedUnits.SelectedIndex.ToString
    End Sub
    ' Initialize when the main window is shown. Get an address from the operator
    Private Sub Test_Shown(sender As System.Object, e As System.EventArgs) Handles MyBase.Shown

        Dim dvaddress As String = My.Settings.IPaddress
        Dim dvport As Short = My.Settings.IPport

        Dim sd As New getAddress

        Do
            sd.tbAddress.Text = dvaddress
            sd.nudPort.Value = dvport
            Try
                If sd.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                    ' Read the contents of testDialog's TextBox.
                    dvaddress = sd.tbAddress.Text
                    dvport = CShort(sd.nudPort.Value)
                Else
                    Me.Close()
                    sd.Dispose()
                    End
                End If
            Catch exc As Exception
                Me.Close()
                End
            End Try

            dvm = New DynaviewModbus.Dynaview(dvaddress, CUInt(dvport))
            If Not dvm.connect() Then
                MessageBox.Show("No Dynaview found at that address, try again")
            Else
                Exit Do
            End If
        Loop While CBool(1)

        If dvaddress <> My.Settings.IPaddress Then
            My.Settings.IPaddress = dvaddress
        End If
        If dvport <> My.Settings.IPport Then
            My.Settings.IPport = dvport
        End If
        My.Settings.Save()
        sd.Dispose()
        Timer1.Start() 'triggers an update once a second

        cbLenUnits.SelectedIndex = 0
        cbSpeedUnits.SelectedIndex = 0
        tbRemoteIPAddr.Text = dvaddress
        tbRemotePort.Text = dvport.ToString
        tbRemoteID.Text = "1"
        Timer1_Tick(sender, e)
    End Sub
    ''' <summary>
    ''' called when we get a new recipe object. Loads all the controls with values
    ''' </summary>
    ''' <param name="myRecipe">A reference to the new recipe object</param>
    ''' <returns>0</returns>
    ''' <remarks>Overloaded</remarks>
    Private Function loadFrontPanel(ByRef myRecipe As Recipe) As Integer
        cbFixedAvg.Checked = myRecipe.FixedAvgEna
        cbWarnAlarmEna.Checked = myRecipe.WarningAlarmsEna
        cbLimitAlarmEna.Checked = myRecipe.LimitAlarmsEna
        cbEyeLightOnDark.Checked = myRecipe.EyeLightOnDarkEna
        cbTextRpt.Checked = myRecipe.TextReportsEna
        cbGraphicRpt.Checked = myRecipe.GraphicReportsEna
        cbKeepData.Checked = myRecipe.RetainReportsEna
        cbContReports.Checked = myRecipe.ContinuiousReportsEna
        cbEyeGating.Checked = myRecipe.EyeGatingEna
        cbAuto.Checked = myRecipe.EyeAutoEna
        tbRecipeName2.Text = myRecipe.RecipeName
        cbLenUnits.SelectedIndex = CInt(myRecipe.ImageLengthUnits)
        cbSpeedUnits.SelectedIndex = CInt(myRecipe.WebSpeedUnits)
        nudWheelFactor.Value = CDec(myRecipe.WheelFactor)
        nudPWMspan.Value = CDec(myRecipe.PWMspan)
        nudTargetValue.Value = CDec(myRecipe.TargetValue)
        nudChartWidth.Value = CDec(myRecipe.ChartWidth)
        nudIgnoreAfterRollChange.Value = CDec(myRecipe.IgnoreFootage)
        nudLimitHigh.Value = CDec(myRecipe.HighLimitAlarm)
        nudWarnHigh.Value = CDec(myRecipe.HighWarningAlarm)
        nudLimitLow.Value = CDec(myRecipe.LowLimitAlarm)
        nudWarnLow.Value = CDec(myRecipe.LowWarningAlarm)
        nudMinPrescaleVal.Value = myRecipe.MinumumPrescaleValue
        nudAvgNum.Value = CDec(CDbl(myRecipe.AvgNumber))
        nudReportInterval.Value = CDec(CDbl(myRecipe.ReportSamplingInterval))
        nudHowMany.Value = CDec(CDbl(myRecipe.SamplesPerInterval))
        nudChartCal.Value = CDec(myRecipe.ChartCal)
        nudEyeGateOffset.Value = CDec(myRecipe.EyeGateOffset)
        nudEyeGateWidth.Value = CDec(myRecipe.EyeGateWidth)
        nudGatesPerSync.Value = CDec(CDbl(myRecipe.GatesPerSync))
        tbRecipeDesc2.Text = myRecipe.RecipeDescription
        RecipeTab.Refresh()
        Return 0
    End Function
    Private Function unloadFrontPanel() As Recipe
        Dim myRecipe As New Recipe

        myRecipe.FixedAvgEna = cbFixedAvg.Checked
        myRecipe.WarningAlarmsEna = cbWarnAlarmEna.Checked
        myRecipe.LimitAlarmsEna = cbLimitAlarmEna.Checked
        myRecipe.EyeLightOnDarkEna = cbEyeLightOnDark.Checked
        myRecipe.TextReportsEna = cbTextRpt.Checked
        myRecipe.GraphicReportsEna = cbGraphicRpt.Checked
        myRecipe.RetainReportsEna = cbKeepData.Checked
        myRecipe.ContinuiousReportsEna = cbContReports.Checked
        myRecipe.EyeGatingEna = cbEyeGating.Checked
        myRecipe.EyeAutoEna = cbAuto.Checked
        myRecipe.RecipeName = tbRecipeName2.Text
        myRecipe.ImageLengthUnits = CType(cbLenUnits.SelectedIndex, ImageLenUnits)
        myRecipe.WebSpeedUnits = CType(cbSpeedUnits.SelectedIndex, WebSpdUnits)
        myRecipe.WheelFactor = nudWheelFactor.Value
        myRecipe.PWMspan = nudPWMspan.Value
        myRecipe.TargetValue = nudTargetValue.Value
        myRecipe.ChartWidth = nudChartWidth.Value
        myRecipe.IgnoreFootage = nudIgnoreAfterRollChange.Value
        myRecipe.HighLimitAlarm = nudLimitHigh.Value
        myRecipe.HighWarningAlarm = nudWarnHigh.Value
        myRecipe.LowLimitAlarm = nudLimitLow.Value
        myRecipe.LowWarningAlarm = nudWarnLow.Value
        myRecipe.MinumumPrescaleValue = CInt(nudMinPrescaleVal.Value)
        myRecipe.AvgNumber = CUInt(CInt(nudAvgNum.Value))
        myRecipe.ReportSamplingInterval = CUInt(CInt(nudReportInterval.Value))
        myRecipe.SamplesPerInterval = CUInt(CInt(nudHowMany.Value))
        myRecipe.ChartCal = nudChartCal.Value
        myRecipe.EyeGateOffset = nudEyeGateOffset.Value
        myRecipe.EyeGateWidth = nudEyeGateWidth.Value
        myRecipe.GatesPerSync = CUInt(CInt(nudGatesPerSync.Value))
        myRecipe.RecipeDescription = tbRecipeDesc2.Text
        Return myRecipe
    End Function
    ''' <summary>
    ''' Called when we get a new state object. Load the new values in the controls
    ''' </summary>
    ''' <param name="myState">A reference to the new state object</param>
    ''' <returns>0</returns>
    ''' <remarks>Overloaded</remarks>
    Private Function loadFrontPanel(ByRef myState As State) As Integer
        cbSavingData.Checked = myState.status.SaveDataF
        cbDataPause.Checked = myState.status.PauseDataF
        cbHeartbeat.Checked = myState.status.Heartbeat
        cbEcho.Checked = myState.status.Echo
        If myState.status.LimitAlarmPresent Then
            tbAlarm.Text = "Limit"
            tbAlarm.BackColor = Color.Pink
        ElseIf myState.status.WarningAlarmPresent Then
            tbAlarm.Text = "Warning"
            tbAlarm.BackColor = Color.Yellow
        Else
            tbAlarm.Text = "None"
            tbAlarm.BackColor = Color.LightGreen
        End If
        cbDataSteady.Checked = myState.status.ProcessSteady
        cbAlarmActive.Checked = myState.LimitAlarmActive Or myState.WarningAlarmActive
        cbLoadRecipeErr.Checked = myState.status.ModbusRecipeLoadErr
        If cbModbusEna.Checked <> myState.status.ModbusRW Then
            cbModbusEna.Checked = myState.status.ModbusRW
        End If
        tbLength.Text = myState.LengthAvg.ToString("F3")
        tbAvgOver.Text = myState.LengthAvgCount.ToString
        tbTarget.Text = myState.TargetValue.ToString("F3")
        tbImageCount.Text = myState.ImageCount.ToString
        tbRollLength.Text = myState.RollLength.ToString("F0")
        tbWebSpeed.Text = myState.WebSpeed.ToString("F1")
        tbFolderName.Text = myState.FolderName
        tbFolderDesc.Text = myState.FolderDescription
        tbJobName.Text = myState.JobName
        tbRollName.Text = myState.RollName
        tbRecipeName.Text = myState.RecipeName
        tbRecipeDesc.Text = myState.RecipeDescription
        tbLenUnits.Text = myState.ImageLengthUnits
        tbTargetUnits.Text = myState.ImageLengthUnits
        tbWebSpdUnits.Text = myState.SpeedUnits
        tbRollLenUnits.Text = myState.RollLengthUnits
        tbRollStartTime.Text = myState.RollStartTime
        DataTab.Refresh()
        Return 0
    End Function
    Private echobit As Boolean = False
    ''' <summary>
    ''' This timer event triggers a querry to the Dynaview
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        Dim dvState As State

        dvState = dvm.GetState()
        loadFrontPanel(dvState)
        dvm.SetEcho(echobit)
        echobit = Not echobit
    End Sub

    Private Sub btnClose_Click(sender As System.Object, e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub
    Private Sub getAndLoadRecipe()
        Dim Recipe As DynaviewModbus.Recipe
        Recipe = dvm.GetRecipe()
        loadFrontPanel(Recipe)
    End Sub
    Private Sub tcSelectTab_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles tcSelectTab.SelectedIndexChanged
        If tcSelectTab.SelectedIndex = 1 Then 'recipe
            getAndLoadRecipe()
        End If
    End Sub
    Private Sub btnUpdate_Click(sender As System.Object, e As System.EventArgs) Handles btnUpdate.Click
        getAndLoadRecipe()
    End Sub
    Private Sub btnNewRoll_Click(sender As System.Object, e As System.EventArgs) Handles btnNewRoll.Click
        dvm.NewRoll()
    End Sub
    Private Sub btnAckAlarm_Click(sender As System.Object, e As System.EventArgs) Handles btnAckAlarm.Click
        dvm.AckAlarm()
    End Sub
    Private Sub cbModbusEna_Click(sender As System.Object, e As System.EventArgs) Handles cbModbusEna.Click
        dvm.RemoteEna(cbModbusEna.Checked)
    End Sub

    Private Sub btnPutRecipe_Click(sender As System.Object, e As System.EventArgs) Handles btnPutRecipe.Click
        Dim myRecipe As Recipe = unloadFrontPanel()
        dvm.PutRecipe(myRecipe)
    End Sub

    Private Sub btnMakeActive_Click(sender As System.Object, e As System.EventArgs) Handles btnMakeActive.Click
        dvm.LoadRecipe()
    End Sub

    Private Sub Test_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        ' Set up the delays for the ToolTip.
        toolTip1.AutoPopDelay = 5000
        toolTip1.InitialDelay = 1000
        toolTip1.ReshowDelay = 500
        ' Force the ToolTip text to be displayed whether or not the form is active.
        toolTip1.ShowAlways = True

        ' Set up the ToolTip text for the Button and Checkbox.
        toolTip1.SetToolTip(Me.btnAckAlarm, "Push to acknowledge an alarm")
        toolTip1.SetToolTip(Me.btnNewRoll, "Push to end the current roll, generate reports and start a new roll")
        toolTip1.SetToolTip(Me.tbLength, "Shows the current measured length")
        toolTip1.SetToolTip(Me.btnUpdate, "Refresh the display from the remote recipe buffer")
        toolTip1.SetToolTip(Me.btnPutRecipe, "Load the remote recipe buffer with this form")
        toolTip1.SetToolTip(Me.cbModbusEna, "Check to enable all recipe management via Modbus")
        toolTip1.SetToolTip(Me.btnMakeActive, "Click to make the remote recipe buffer the active recipe")
        toolTip1.SetToolTip(Me.tbRecipeName2, "Short Recipe Name(10 characters max)")
        toolTip1.SetToolTip(Me.tbRecipeDesc2, "Long Recipe Description(39 characters max)")
        toolTip1.SetToolTip(Me.nudTargetValue, "Target image length value")
        toolTip1.SetToolTip(Me.nudWheelFactor, "Multiplier for image length. Use to compensate for wheel wear or slip")
        toolTip1.SetToolTip(Me.nudPWMspan, "Sets full scale for the 4-20ma output")
        toolTip1.SetToolTip(Me.nudChartWidth, "Sets full scale for the operator display")
        toolTip1.SetToolTip(Me.nudChartCal, "Not used")
        toolTip1.SetToolTip(Me.nudIgnoreAfterRollChange, "Ignore alarms for this length after a roll change")
        toolTip1.SetToolTip(Me.nudLimitHigh, "High limit alarm value")
        toolTip1.SetToolTip(Me.nudWarnHigh, "High warning alarm value")
        toolTip1.SetToolTip(Me.nudLimitLow, "Low limit alarm value")
        toolTip1.SetToolTip(Me.nudWarnLow, "Low warning alarm value")
        toolTip1.SetToolTip(Me.cbLimitAlarmEna, "High and low limit alarms are enabled if checked")
        toolTip1.SetToolTip(Me.cbWarnAlarmEna, "High and low warning alarms are enabled if checked")
        toolTip1.SetToolTip(Me.cbLenUnits, "Select the length units from the drop-down list")
        toolTip1.SetToolTip(Me.cbSpeedUnits, "Select the speed units from the drop-down list")
        toolTip1.SetToolTip(Me.nudMinPrescaleVal, "Average selection, see Help")
        toolTip1.SetToolTip(Me.cbFixedAvg, "If checked average over a multiple of prescale. If not checked average over at least prescale. See Help")
        toolTip1.SetToolTip(Me.nudMinPrescaleVal, "Number of images to average")
        toolTip1.SetToolTip(Me.nudAvgNum, "Sets the size of the boxcar smooth")
        toolTip1.SetToolTip(Me.cbLoadRecipeErr, "Could not make the remote buffer active if checked. Is ModbusRW set?")
        'toolTip1.SetToolTip(Me., "")
        'toolTip1.SetToolTip(Me., "")
        'toolTip1.SetToolTip(Me., "")
        'toolTip1.SetToolTip(Me., "")
        'toolTip1.SetToolTip(Me., "")
        'toolTip1.SetToolTip(Me., "")
        'toolTip1.SetToolTip(Me., "")
        'toolTip1.SetToolTip(Me., "")
        'toolTip1.SetToolTip(Me., "")
        'toolTip1.SetToolTip(Me., "")
    End Sub

    Private Sub cbModbusEna_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles cbModbusEna.CheckedChanged
        If cbModbusEna.Checked Then
            toolTip1.SetToolTip(Me.cbModbusEna, "Uncheck to enable all recipe management local on the Dynaview")
        Else
            toolTip1.SetToolTip(Me.cbModbusEna, "Check to enable all recipe management remotely")
        End If
    End Sub

    Private Sub btnSmoothHelp_Click(sender As System.Object, e As System.EventArgs) Handles btnSmoothHelp.Click
        MessageBox.Show( _
        "Averaging:" & vbCrLf & _
        "The Dynaview picks up a length value from the encoder every 500ms. This value is length over " & _
        "the number of images that have passed the eye. In the default condition (Fixed Avg. unchecked " & _
        "and Min. Prescale Value 0) the Dynaview divides the overall length by the number of images to " & _
        "find the length of the image. The number of images averaged is shown on the screen as ""Now Averaging"". " & _
        "You can change this default behavior in two ways." & vbCrLf & _
        "1) Force a minimum precision. Leave Fixed Avg. unchecked, put a value in Min. Prescale Value. This will force " & _
        "the Dynaview to always average over at least the number of images specified." & vbCrLf & _
        "2) Force the Dynaview to always average over a multiple of some number of images. This is done typically to always " & _
        "measure over one revolution of a central impression press. Here check Fixed Avg. and put the number of plates " & _
        "in Min. Prescale Value." & vbCrLf & _
        "Smoothing:" & vbCrLf & _
        "Smoothing is done after the averaging discussed above. Dynaview can smooth using a boxcar average. You specify the " & _
        "length of the boxcar in ""Images to smooth"". A boxcar average is where you add up the last n samples, then divide by n. " & _
        "The boxcar always contains the last n samples as new samples are added and stale samples are removed", _
        "Smoothing and Averaging")

    End Sub

    Private Sub btnReportHelp_Click(sender As System.Object, e As System.EventArgs) Handles btnReportHelp.Click
        MessageBox.Show("By default Dynaview samples data for reports. You specify how many samples to record and the interval " & _
                        "in the boxes ""No. of Sample"" and ""Interval"". If you want the Dynaview to record every data point " & _
                        "(one data point every 500ms or one data point every image, depending on which is slower) check ""Ena Continuious""." & _
                        "", _
                        "Reports")
    End Sub
End Class
